%% binarni detektor kvara

% kvar detektiramo onda kad je pwm signal razlicit od nula,
% a iznos struje ne mijenja vrijednost. Budui da su mjerenja 
% struje zaumljena potrebno je ispitati nekoliko uzastopnih 
% uzoraka, te ukoliko se vrijednost struje i dalje ne mijenja, propulzor
% je u kvaru.
clc
podaci;
skaliranje_struja;
skaliranje_struja_napon;
kvar = zeros(6,n);
fault=zeros(6,n);
avg=zeros(1,i);
 
%raunanje prosjecne vrijednosti struje uz PWM=0
for i=1:6
    sum=0;
    k=0;
        for j= 2:n
        if(pwm(i,j)== 0 && pwm(i,j-1) == 0)
        x=sum;
        sum =x + struja(i,j);
        k = k+1;
        end
        avg(1,i) = sum/k ;
        end
end

for i = 1:6
    for j = 2:n
        if ( ((pwm(i,j) - pwm(i,j-1) ~= 0) || pwm(i,j)~= 0) && (struja(i,j) <= avg(1,i)))
            kvar(i,j) = 1;
         
        end
    end
end
 
for i= 1:6
    ind = 0;
    for j = 3 : n
        if ( kvar(i,j) == 1 && kvar(i,j-1) == 1 && kvar(i,j-2) == 1  )
            ind = 1;
            fault(i,j)=1;
%              fprintf('Kvar je detektiran u %d. uzorku na %d. motoru\n',j,i)
        end
    end
    if ( ind == 1)
        fprintf('Propulzor %d je u kvaru \n', i)
    else
        fprintf ('Nema kvara na %d. propulzoru \n',i)
    end
end


plotanje;